"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StripeApi = void 0;
class StripeApi {
    constructor() {
        this.name = 'stripeApi';
        this.displayName = 'Stripe API';
        this.documentationUrl = 'stripe';
        this.properties = [
            {
                displayName: 'Secret Key',
                name: 'secretKey',
                type: 'string',
                default: '',
            },
        ];
        this.authenticate = {
            type: 'generic',
            properties: {
                headers: {
                    Authorization: '=Bearer {{$credentials.secretKey}}',
                },
            },
        };
        this.test = {
            request: {
                baseURL: 'https://api.stripe.com/v1',
                url: '/charges',
                json: true,
            },
        };
    }
}
exports.StripeApi = StripeApi;
//# sourceMappingURL=StripeApi.credentials.js.map