"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deleteDatapoint = exports.updateDatapoint = exports.getAllDatapoints = exports.createDatapoint = void 0;
const GenericFunctions_1 = require("./GenericFunctions");
async function createDatapoint(data) {
    const credentials = await this.getCredentials('beeminderApi');
    const endpoint = `/users/${credentials.user}/goals/${data.goalName}/datapoints.json`;
    return GenericFunctions_1.beeminderApiRequest.call(this, 'POST', endpoint, data);
}
exports.createDatapoint = createDatapoint;
async function getAllDatapoints(data) {
    const credentials = await this.getCredentials('beeminderApi');
    const endpoint = `/users/${credentials.user}/goals/${data.goalName}/datapoints.json`;
    if (data.count !== undefined) {
        return GenericFunctions_1.beeminderApiRequest.call(this, 'GET', endpoint, {}, data);
    }
    return GenericFunctions_1.beeminderApiRequestAllItems.call(this, 'GET', endpoint, {}, data);
}
exports.getAllDatapoints = getAllDatapoints;
async function updateDatapoint(data) {
    const credentials = await this.getCredentials('beeminderApi');
    const endpoint = `/users/${credentials.user}/goals/${data.goalName}/datapoints/${data.datapointId}.json`;
    return GenericFunctions_1.beeminderApiRequest.call(this, 'PUT', endpoint, data);
}
exports.updateDatapoint = updateDatapoint;
async function deleteDatapoint(data) {
    const credentials = await this.getCredentials('beeminderApi');
    const endpoint = `/users/${credentials.user}/goals/${data.goalName}/datapoints/${data.datapointId}.json`;
    return GenericFunctions_1.beeminderApiRequest.call(this, 'DELETE', endpoint);
}
exports.deleteDatapoint = deleteDatapoint;
//# sourceMappingURL=Beeminder.node.functions.js.map