"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.REQUIRED_N8N_ITEM_KEYS = exports.standardizeOutput = exports.isObject = void 0;
function isObject(maybe) {
    return typeof maybe === 'object' && maybe !== null && !Array.isArray(maybe);
}
exports.isObject = isObject;
function isTraversable(maybe) {
    return isObject(maybe) && typeof maybe.toJSON !== 'function' && Object.keys(maybe).length > 0;
}
function standardizeOutput(output) {
    for (const [key, value] of Object.entries(output)) {
        if (!isTraversable(value))
            continue;
        output[key] =
            value.constructor.name !== 'Object'
                ? JSON.stringify(value)
                : standardizeOutput(value);
    }
    return output;
}
exports.standardizeOutput = standardizeOutput;
exports.REQUIRED_N8N_ITEM_KEYS = new Set(['json', 'binary', 'pairedItem']);
//# sourceMappingURL=utils.js.map