"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.router = void 0;
const sheet = __importStar(require("./sheet/Sheet.resource"));
const spreadsheet = __importStar(require("./spreadsheet/SpreadSheet.resource"));
const GoogleSheet_1 = require("../helpers/GoogleSheet");
const GoogleSheets_utils_1 = require("../helpers/GoogleSheets.utils");
async function router() {
    const operationResult = [];
    try {
        const resource = this.getNodeParameter('resource', 0);
        const operation = this.getNodeParameter('operation', 0);
        const googleSheets = {
            resource,
            operation,
        };
        if (googleSheets.resource === 'sheet') {
            const { mode, value } = this.getNodeParameter('documentId', 0);
            const spreadsheetId = (0, GoogleSheets_utils_1.getSpreadsheetId)(mode, value);
            const googleSheet = new GoogleSheet_1.GoogleSheet(spreadsheetId, this);
            let sheetId = '';
            if (operation !== 'create') {
                sheetId = this.getNodeParameter('sheetName', 0, undefined, {
                    extractValue: true,
                });
            }
            if (sheetId === 'gid=0') {
                sheetId = '0';
            }
            let sheetName = '';
            switch (operation) {
                case 'create':
                    sheetName = spreadsheetId;
                    break;
                case 'delete':
                    sheetName = sheetId;
                    break;
                case 'remove':
                    sheetName = `${spreadsheetId}||${sheetId}`;
                    break;
                default:
                    sheetName = await googleSheet.spreadsheetGetSheetNameById(sheetId);
            }
            operationResult.push(...(await sheet[googleSheets.operation].execute.call(this, googleSheet, sheetName, sheetId)));
        }
        else if (googleSheets.resource === 'spreadsheet') {
            operationResult.push(...(await spreadsheet[googleSheets.operation].execute.call(this)));
        }
    }
    catch (err) {
        if (this.continueOnFail()) {
            operationResult.push({ json: this.getInputData(0)[0].json, error: err });
        }
        else {
            if (err.message &&
                (err.message.toLowerCase().includes('bad request') ||
                    err.message.toLowerCase().includes('uknown error')) &&
                err.description) {
                err.message = err.description;
                err.description = undefined;
            }
            throw err;
        }
    }
    return [operationResult];
}
exports.router = router;
//# sourceMappingURL=router.js.map