"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.execute = void 0;
const transport_1 = require("../../transport");
async function execute(sheet, sheetName) {
    const returnData = [];
    const items = this.getInputData();
    for (let i = 0; i < items.length; i++) {
        const [spreadsheetId, sheetWithinDocument] = sheetName.split('||');
        const requests = [
            {
                deleteSheet: {
                    sheetId: sheetWithinDocument,
                },
            },
        ];
        const responseData = await transport_1.apiRequest.call(this, 'POST', `/v4/spreadsheets/${spreadsheetId}:batchUpdate`, { requests });
        delete responseData.replies;
        returnData.push(responseData);
    }
    return this.helpers.returnJsonArray(returnData);
}
exports.execute = execute;
//# sourceMappingURL=remove.operation.js.map