"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.googleApiCredentialTest = void 0;
const transport_1 = require("../transport");
async function googleApiCredentialTest(credential) {
    try {
        const tokenRequest = await transport_1.getAccessToken.call(this, credential.data);
        if (!tokenRequest.access_token) {
            return {
                status: 'Error',
                message: 'Could not generate a token from your private key.',
            };
        }
    }
    catch (err) {
        return {
            status: 'Error',
            message: `Private key validation failed: ${err.message}`,
        };
    }
    return {
        status: 'OK',
        message: 'Connection successful!',
    };
}
exports.googleApiCredentialTest = googleApiCredentialTest;
//# sourceMappingURL=credentialTest.js.map