"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getValue = exports.getResolvables = void 0;
function getResolvables(html) {
    if (!html)
        return [];
    const resolvables = [];
    const resolvableRegex = /({{[\s\S]*?}})/g;
    let match;
    while ((match = resolvableRegex.exec(html)) !== null) {
        if (match[1]) {
            resolvables.push(match[1]);
        }
    }
    return resolvables;
}
exports.getResolvables = getResolvables;
const extractFunctions = {
    attribute: ($, valueData) => $.attr(valueData.attribute),
    html: ($, _valueData) => $.html() || undefined,
    text: ($, _valueData) => $.text(),
    value: ($, _valueData) => $.val(),
};
function getValue($, valueData, options) {
    const value = extractFunctions[valueData.returnValue]($, valueData);
    if (options.trimValues === false || value === undefined) {
        return value;
    }
    return value.trim();
}
exports.getValue = getValue;
//# sourceMappingURL=utils.js.map