"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.peekalinkApiRequest = void 0;
const n8n_workflow_1 = require("n8n-workflow");
async function peekalinkApiRequest(method, resource, body = {}, qs = {}, uri, option = {}) {
    try {
        const credentials = await this.getCredentials('peekalinkApi');
        let options = {
            headers: {
                'X-API-Key': credentials.apiKey,
            },
            method,
            qs,
            body,
            uri: uri || `https://api.peekalink.io${resource}`,
            json: true,
        };
        options = Object.assign({}, options, option);
        return await this.helpers.request(options);
    }
    catch (error) {
        throw new n8n_workflow_1.NodeApiError(this.getNode(), error);
    }
}
exports.peekalinkApiRequest = peekalinkApiRequest;
//# sourceMappingURL=GenericFunctions.js.map