"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Helpers = __importStar(require("../../../test/nodes/Helpers"));
const ExecuteWorkflow_1 = require("../../../test/nodes/ExecuteWorkflow");
const path_1 = __importDefault(require("path"));
describe('Test Read PDF Node', () => {
    beforeEach(async () => {
        await Helpers.initBinaryDataManager();
    });
    const workflow = Helpers.readJsonFileSync('nodes/ReadPdf/test/ReadPDF.workflow.json');
    const node = workflow.nodes.find((n) => n.name === 'Read Binary File');
    node.parameters.filePath = path_1.default.join(__dirname, 'sample.pdf');
    const testData = {
        description: 'nodes/ReadPdf/test/ReadPDF.workflow.json',
        input: {
            workflowData: workflow,
        },
        output: {
            nodeData: {
                'Read PDF': [
                    [
                        {
                            json: {
                                numpages: 1,
                                numrender: 1,
                                info: {
                                    PDFFormatVersion: '1.4',
                                    IsAcroFormPresent: false,
                                    IsXFAPresent: false,
                                    Title: 'sample',
                                    Producer: 'iLovePDF',
                                    ModDate: 'D:20230210122750Z',
                                },
                                metadata: null,
                                text: '\n\nN8N\nSample PDF\nLorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor\ninvidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et\njusto duo dolores et ea rebum.',
                                version: '1.10.100',
                            },
                        },
                    ],
                ],
            },
        },
    };
    const nodeTypes = Helpers.setup(testData);
    test(testData.description, async () => {
        const { result } = await (0, ExecuteWorkflow_1.executeWorkflow)(testData, nodeTypes);
        const resultNodeData = Helpers.getResultNodeData(result, testData);
        delete resultNodeData[0].resultData[0][0].binary;
        expect(resultNodeData[0].resultData).toEqual(testData.output.nodeData['Read PDF']);
        expect(result.finished).toEqual(true);
    });
});
//# sourceMappingURL=ReadPDF.test.js.map