"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ExecuteWorkflow_1 = require("../../../../test/nodes/ExecuteWorkflow");
const Helpers = __importStar(require("../../../../test/nodes/Helpers"));
describe('Execute Stop and Error Node', () => {
    const tests = [
        {
            description: 'should run stopAndError node',
            input: {
                workflowData: {
                    nodes: [
                        {
                            parameters: {},
                            id: 'b1dcfb89-3dda-4d18-bdd6-c12d8dee70d2',
                            name: 'When clicking "Execute Workflow"',
                            type: 'n8n-nodes-base.manualTrigger',
                            typeVersion: 1,
                            position: [820, 400],
                        },
                        {
                            parameters: {
                                errorType: 'errorObject',
                                errorObject: '{\n"code": 404,\n"message": "error object from node"\n}',
                            },
                            id: '5dae596a-8956-4149-ba9d-36b6b5e80c4a',
                            name: 'Stop and Error1',
                            type: 'n8n-nodes-base.stopAndError',
                            typeVersion: 1,
                            position: [1080, 300],
                            continueOnFail: true,
                        },
                        {
                            parameters: {
                                errorMessage: 'error message from node',
                            },
                            id: '196ca8fe-994d-46aa-a0ed-bd9beeaa490e',
                            name: 'Stop and Error',
                            type: 'n8n-nodes-base.stopAndError',
                            typeVersion: 1,
                            position: [1080, 480],
                            continueOnFail: true,
                        },
                    ],
                    connections: {
                        'When clicking "Execute Workflow"': {
                            main: [
                                [
                                    {
                                        node: 'Stop and Error1',
                                        type: 'main',
                                        index: 0,
                                    },
                                    {
                                        node: 'Stop and Error',
                                        type: 'main',
                                        index: 0,
                                    },
                                ],
                            ],
                        },
                    },
                },
            },
            output: {
                nodeExecutionOrder: ['Start'],
                nodeData: {},
            },
        },
    ];
    const nodeTypes = Helpers.setup(tests);
    for (const testData of tests) {
        test(testData.description, async () => {
            const { result } = await (0, ExecuteWorkflow_1.executeWorkflow)(testData, nodeTypes);
            expect(result.finished).toBeUndefined();
            const stopAndErrorRunData = result.data.resultData.runData['Stop and Error'];
            const stopAndErrorMessage = stopAndErrorRunData[0].error.message;
            expect(stopAndErrorMessage).toEqual('error message from node');
            const stopAndError1RunData = result.data.resultData.runData['Stop and Error1'];
            const stopAndError1Object = stopAndError1RunData[0].error.cause;
            expect(stopAndError1Object).toEqual({
                code: 404,
                message: 'error object from node',
                name: 'User-thrown error',
            });
        });
    }
});
//# sourceMappingURL=StopAndError.test.js.map