"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.executeWorkflow = void 0;
const n8n_core_1 = require("n8n-core");
const n8n_workflow_1 = require("n8n-workflow");
const Helpers = __importStar(require("./Helpers"));
async function executeWorkflow(testData, nodeTypes) {
    const executionMode = 'manual';
    const workflowInstance = new n8n_workflow_1.Workflow({
        id: 'test',
        nodes: testData.input.workflowData.nodes,
        connections: testData.input.workflowData.connections,
        active: false,
        nodeTypes,
    });
    const waitPromise = await (0, n8n_workflow_1.createDeferredPromise)();
    const nodeExecutionOrder = [];
    const additionalData = Helpers.WorkflowExecuteAdditionalData(waitPromise, nodeExecutionOrder);
    const workflowExecute = new n8n_core_1.WorkflowExecute(additionalData, executionMode);
    const executionData = await workflowExecute.run(workflowInstance);
    const result = await waitPromise.promise();
    return { executionData, result, nodeExecutionOrder };
}
exports.executeWorkflow = executeWorkflow;
//# sourceMappingURL=ExecuteWorkflow.js.map